using Microsoft.AspNetCore.Components;
using Microsoft.JSInterop;
using System.Data.SqlClient;
using System.Data;
using sirkettodo.Pages.EntityFramework;
using static sirkettodo.Pages.UserData;
namespace sirkettodo.Pages.AdminPage 
{
    public class AdminTeamCrud:ComponentBase
    {
        public string team_id{get;set;}
        public string team_name{get;set;}
        public AdminUserConfirm UserConfirms;
        public List<Team> TeamTable=new List<Team>();
        [Inject]
        public EntitySqlService service{get;set;}
        [Inject]
        IJSRuntime JSRuntime { get; set; }

        protected override async Task OnInitializedAsync() 
        {
            if(UserData.Data.UserEmailData != "NULL" && UserData.Data.UserPasswordData != "NULL" && UserData.Data.UserRoleData == 0)
            {
                TeamTable.Clear();
                TeamTable=GetTeam();
                StateHasChanged();
            }
            else
            {
                JSRuntime.InvokeVoidAsync("gologin");
            }
        }

        public List<Team> GetTeam(){
            TeamTable= service.GetAllTeams();
            return TeamTable;
        }

        public void OpenMenu(ChangeEventArgs e)
        {
            string value=e.Value.ToString();
            
            if(value=="0")
            {
                JSRuntime.InvokeVoidAsync("openaddteam");
                Console.WriteLine(value);
            }
            else if(value=="1")
            {
                JSRuntime.InvokeVoidAsync("openupdateteam");
                Console.WriteLine(value);
            }
            else if(value=="2")
            {
                JSRuntime.InvokeVoidAsync("opendeleteteam");
                Console.WriteLine(value);
            }
        }

        public void AddTeam()
        {
            Team team=new Team();
            team.team_name=team_name;
            service.InsertTeamsAsync(team);
            team.team_id=TeamTable.Last().team_id+1;
            TeamTable.Add(team);
        }

        public async void UpdateTeam()
        {
            Team team = await Task.Run(() => service.GetTeamAsync(Convert.ToInt32(team_id)));
            team.team_name=team_name;
            await service.UpdateTeamAsync(team);
            await InvokeAsync(StateHasChanged);
        }

        public async void SearchTeam()
        {
            Team team = await Task.Run(() => service.GetTeamAsync(Convert.ToInt32(team_id)));
            if(team!=null)
            {
                DeleteTeam(team);
                TeamTable.Remove(team);
            }
        }

        protected async void DeleteTeam(Team team)
        {
            await  service.DeleteTeamAsync(team);
            await InvokeAsync(StateHasChanged);
        }


        /* public static string database = @"workstation id=sirkettodo.mssql.somee.com;packet size=4096;user id=Ramiz058_SQLLogin_1;pwd=rs91p7j2w2;data source=sirkettodo.mssql.somee.com;persist security info=False;initial catalog=sirkettodo";    
        public static SqlConnection connection = new SqlConnection(database);
        public static SqlCommand command = connection.CreateCommand();*/

        /*public void UpdateTeam(){
        if(team_name!="")
        {
        command.CommandText = "insert into team values ('"+team_name+"')";
        connection.Open();
        command.ExecuteNonQuery();
        connection.Close();
        team_id="";
        team_name="";
        TeamTable.Clear();
        TeamTable=GetTeam();
        }
        }*/

        /*public void AddTeam(){
        if(team_name!="")
        {
            command.CommandText = "insert into team values ('"+team_name+"')";
            connection.Open();
            command.ExecuteNonQuery();
            connection.Close();
            team_name="";
            TeamTable.Clear();
            TeamTable=GetTeam();
        }
        }*/

        /*public void DeleteTeam(){
        if(team_id!="")
        {
            command.CommandText = "delete from team where team_id="+team_id+"";
            connection.Open();
            command.ExecuteNonQuery();
            connection.Close();
            team_id="";
            TeamTable.Clear();
            TeamTable=GetTeam();
        }
        }*/

        /*public List<Team> GetTeam()
        {
            connection.Open();
            string sql = "select *from team";  
            SqlDataAdapter DataAdapterTeamTable= new SqlDataAdapter (sql, connection);
            SqlCommandBuilder CommandBuilder = new SqlCommandBuilder(DataAdapterTeamTable);
            DataSet DataSetTeamTable = new DataSet();
            try
            {
                DataAdapterTeamTable.Fill(DataSetTeamTable, "TeamTable");
                //error+=DataSetTeamTable.Tables[0].Rows.Count.ToString();
                for (int i = 0; i < DataSetTeamTable.Tables[0].Rows.Count; i++)  
                {  
                Team getTeam = new Team(); 
                getTeam.team_id = Int32.Parse(DataSetTeamTable.Tables[0].Rows[i]["team_id"].ToString());  
                last_team_id=getTeam.team_id;
                getTeam.team_name = DataSetTeamTable.Tables[0].Rows[i]["team_name"].ToString();  
                TeamTable.Add(getTeam);
                }
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex);
            }
            connection.Close();
            return TeamTable;
        }*/
    }
}